/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOCOR                                                 */
/* Tabela : GRUPOCOR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPOCOR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPOCOR
GO

CREATE TRIGGER DTULTATU_GRUPOCOR
ON GRUPOCOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOCOR', null, 'CDGRPOCOR='+ CDGRPOCOR+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOCOR
      SET DTULTATUGOCR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(GRUPOCOR.CDGRPOCOR,0) = ISNULL(INSERTED.CDGRPOCOR,0));
   END;
END;
GO


UPDATE GRUPOCOR SET DTULTATUGOCR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUGOCR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUGOCR' and
            type = 'D')
   ALTER TABLE GRUPOCOR DROP CONSTRAINT DEFAULT_DTULTATUGOCR
GO

ALTER TABLE GRUPOCOR ADD CONSTRAINT DEFAULT_DTULTATUGOCR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUGOCR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRUPOCOR','4.11.194';
GO

