/* Teknisa - Tecnologia em Informtica

Nome: 3955_EXPFUNO_BUSCA_SITUACAO_COLETA_PROD.SQL

Descrio:
Funo para retornar o identificador da cor da coleta em relao a quantidade a expedir
N - Nulo
M - Amarelo (QTITEMPROD > QTRESPRODPED)
V - Verde (QTITEMPROD = QTRESPRODPED)
A - Azul (QTITEMPROD < QTRESPRODPED < (QTITEMPROD + PERCENTUAL ADICIONAL)
E - Vermelho (QTITEMPROD < QTRESPRODPED > (QTITEMPROD + PERCENTUAL ADICIONAL)



@c:\web_605\Sql\End_Conv\SqlServer\3955_EXPFUNS_BUSCA_SITUACAO_COLETA_PROD.sql
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'BUSCA_SITUACAO_COLETA_PROD' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION BUSCA_SITUACAO_COLETA_PROD
GO


CREATE FUNCTION BUSCA_SITUACAO_COLETA_PROD(
   @P_CDFILIAL     VARCHAR(04),
   @P_NRLANCTONF   VARCHAR(10),
   @P_CDPRODUTO    VARCHAR(10)) RETURNS VARCHAR
AS
BEGIN


   DECLARE @V_QTITEMPROD   DOUBLE PRECISION;
   DECLARE @V_QTRESPRODPED DOUBLE PRECISION;
   DECLARE @V_QTPERADIC    DOUBLE PRECISION;
   DECLARE @V_VRPEADIEXP   DOUBLE PRECISION;
   DECLARE @V_RESULT       VARCHAR(01);


   SELECT @V_QTITEMPROD = SUM(QTEXPEDIR)
     FROM ITEMPRODUTO
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF
      AND CDPRODUTO  = @P_CDPRODUTO;

   SELECT @V_VRPEADIEXP = CASE MAX(IDPERADIEXP) WHEN 'S' THEN MAX(VRPEADIEXP) ELSE 0 END
     FROM PAREXPEDICAO
    WHERE CDFILIAL = @P_CDFILIAL;

   SET @V_QTPERADIC =   ROUND(@V_QTITEMPROD+((@V_VRPEADIEXP/100)*@V_QTITEMPROD), 2);

   SELECT @V_QTRESPRODPED = SUM(QTRESPRODPED)
      FROM RESERITEMPROD
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF
      AND CDPRODUTO  = @P_CDPRODUTO;

   IF ((@V_QTRESPRODPED = 0) OR (@V_QTRESPRODPED IS NULL)) BEGIN
      SET @V_RESULT = 'N';
   END
   ELSE IF (@V_QTRESPRODPED = @V_QTITEMPROD) BEGIN
      SET @V_RESULT = 'V';
   END
   ELSE IF ((@V_QTRESPRODPED > @V_QTITEMPROD) AND (@V_QTRESPRODPED <= @V_QTPERADIC)) BEGIN
      SET @V_RESULT = 'A';
   END
   ELSE IF ((@V_QTRESPRODPED > @V_QTITEMPROD) AND (@V_QTRESPRODPED > @V_QTPERADIC)) BEGIN
      SET @V_RESULT = 'E';
   END
   ELSE BEGIN
      SET @V_RESULT = 'M';
   END;

   RETURN(@V_RESULT);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'BUSCA_SITUACAO_COLETA_PROD','0.00.000';
GO

